<?php

namespace PublicationBundle\Controller;

use AppBundle\Entity\Publication;
use AppBundle\Form\PublicationType;
use AppBundle\Form\RecherchePublicationType;
use Symfony\Bundle\FrameworkBundle\Controller\Controller;
use Symfony\Component\HttpFoundation\Request;
use Knp\Snappy\Pdf;
use Symfony\Component\HttpFoundation\File\UploadedFile;
use Symfony\Component\HttpFoundation\Response;



class PublicationController extends Controller
{
    /**
     * @return string
     */
    private function generateUniqueFileName()
    {
        // md5() reduces the similarity of the file names generated by
        // uniqid(), which is based on timestamps
        return md5(uniqid());
    }
    public function AjoutPublicationAction(Request $request){



        $publication=new Publication();
        $now = new \DateTime('now');
        $Form=$this->createForm(PublicationType::class,$publication);
        $Form->handleRequest($request);
        if ($Form->isSubmitted() && $Form->isValid()) {


            // $file stores the uploaded PDF file
            /** @var UploadedFile $file */
            $file = $Form->get('image')->getData();

            $fileName = $this->generateUniqueFileName().'.'.$file->guessExtension();

            // Move the file to the directory where brochures are stored
            $PhotoDir=$this->getParameter('kernel.root_dir').'/../web/uploads';
            $file->move($PhotoDir,$fileName);

            // Update the 'brochure' property to store the PDF file name
            // instead of its contents
            $publication->setImage($fileName);

            $em = $this->getDoctrine()->getManager();
                $em->persist($publication);
                $em->flush();

            return $this->redirectToRoute('_AfficherPublication');
            }


        return $this->render('@Publication/AjoutPublication.html.twig',array('form'=>$Form->createView()));
    }

    public function AfficherPublicationAction(Request $request)
    {

        $em=$this->getDoctrine()->getManager();
        $publication=$em->getRepository('AppBundle:Publication')->findAll();


        return $this->render('@Publication/AfficherPublication.html.twig',
            array(
                'v'=>$publication
            ));
    }

    public function AfficherPublicationFrontAction(Request $request)
    {

        $em=$this->getDoctrine()->getManager();
        $listepublication=$em->getRepository('AppBundle:Publication')->findAll();
        $publication  = $this->get('knp_paginator')->paginate($listepublication, $request->query->get('page', 1), /*page number*/
            6 /*limit per page*/
        );

        return $this->render('@Publication/AfficherPublicationFront.html.twig',
            array(
                'v'=>$publication
            ));
    }

    public function SupprimerPublicationAction( $idPub){

        $em=$this->getDoctrine()->getManager();
        $pub=$em->getRepository("AppBundle:Publication")->find($idPub);
        $em->remove($pub);
        $em->flush();


        return $this->redirectToRoute('_AfficherPublication');
    }


    public function ModifierPublicationAction(Request $request,$idPub){



      $em=$this->getDoctrine()->getManager();
      $publication=$em->getRepository("AppBundle:Publication")->find($idPub);
        $Form=$this->createForm(PublicationType::class,$publication);
        $Form->handleRequest($request);
        if ($Form->isSubmitted() && $Form->isValid()) {
            // $file stores the uploaded PDF file
            /** @var UploadedFile $file */
            $file = $Form->get('image')->getData();

            $fileName = $this->generateUniqueFileName().'.'.$file->guessExtension();

            // Move the file to the directory where brochures are stored
            $PhotoDir=$this->getParameter('kernel.root_dir').'/../web/uploads';
            $file->move($PhotoDir,$fileName);

            // Update the 'brochure' property to store the PDF file name
            // instead of its contents
            $publication->setImage($fileName);


            $em = $this->getDoctrine()->getManager();

            $em->persist($publication);
            $em->flush();
            echo '<script type="text/javascript">' . 'alert("Ajout Avec Succes ");' . '</script>';
            return $this->redirectToRoute('_AfficherPublication');
        }



        return $this->render('@Publication/ModifierPublication.html.twig',array('form'=>$Form->createView()));
    }


    public function AfficheDetailAction($idPub)
    {
        $em= $this->getDoctrine()->getManager();

        $publication=$em->getRepository("AppBundle:Publication")->find($idPub);
        return $this->render('@Publication/AfficheDetail.html.twig', array(
            "v"=>$publication));
    }
    public function RecherchePublicationAction (Request $request){
        $form = $this->createForm(RecherchePublicationType::class);
        $form->handleRequest($request);
        $em = $this->getDoctrine()->getManager();
        $Type = $form['Type']->getData();
        $Titre = $form['Titre']->getData();

        $voyage = $em->getRepository("AppBundle:Publication")->recherche3($Type,$Titre);
        if (empty($Type) && (!empty($Titre))) {
            $voyage = $em->getRepository("AppBundle:Publication")->recherche2($Titre);
        }
        if (empty($Titre) && (!empty($Type))) {
            $voyage = $em->getRepository("AppBundle:Publication")->recherche($Type);
        }





        return $this->render('@Publication/RecherchePublication.html.twig',array('v'=>$voyage, 'form' => $form->createView()));


    }


    public function sortAction($sort)
    {
        $entityManager = $this->getDoctrine()->getManager();

        if ($sort=='ASC'){
            $query = $entityManager->createQuery(
                'SELECT v 
    FROM AppBundle:Publication v
    ORDER BY v.date ASC'
            );
        }else {
            $query = $entityManager->createQuery(
                'SELECT v
    FROM AppBundle:Publication v
    ORDER BY v.date DESC'
            );
        }


        $v = $query->getResult();

        return $this->render('@Publication/AfficherPublication.html.twig', array(
            'v' => $v,
        ));
    }

    public function pdfAction()
    {   $em = $this->getDoctrine()->getManager();
        $publication=$em->getRepository('AppBundle:Publication')->findAll();
        $snappy = $this->get('knp_snappy.pdf');

        $html = $this->renderView('@Publication/pdf.html.twig', array('publication'=>$publication
            //..Send some data to your view if you need to //
        ));

        $filename = 'Mon Article';


        return new Response(

            $snappy->getOutputFromHtml($html),
            200,
            array(
                'Content-Type'          => 'application/pdf',
                'Content-Disposition'   => 'inline; filename="'.$filename.'.pdf"'
            )
        )
            ;
    }

}
